#include "common.h"

#ifndef chessclock_types
#define chessclock_types
#define NOPLAYER  0
#endif

//The chessclock object takes care of time management concerning chess games
class chessclock{
      public:
      chessclock();       
      void setClock(int ms, int moves);			//Stops the clock if running.
												//set time for each side. set movesLeft 
      void increaseTime(int playingSide, int ms);//increase the time of one side by ms
      void setTime(int playingSide, int ms);	//set the time of one side by ms
      
      void startClock(int startClockSide);		//starts clock of one side,  
												//stops clock for the other
      void stopClock();							//stops clock for both sides
      int getTimeLeft(int playingSide);			//returns ms left for white/black
      int getTimeNextMove(int playingSide);		//calculates the time that can be spent on
												//the next move. 
      
      private:
      timer timer1;
      int movesPerRound;
      int timePerRound;
      int margin;
      int timeLeft[2];//black=0, white=1
      int movesLeft[2];//black=0, white=1
      int runningSide;
      int startTime;
      int stopTime;   
	  int incrementalClock;
	  int movesHalfGame;
};
