#include "common.h"
#include <windows.h>

extern FILE* debugfile;


// global thread callback
unsigned int pondering_proc(void* param) {
	pondering* tp = (pondering*)param;
	tp->run();
	return 0;
}


pondering::pondering(hashtable &hashtableInput, board &rootInit, EGTBProbe* egtb):s(hashtableInput, ponderingEnabled, egtb), root(rootInit){
    ponderingEnabled=FALSE;
    m_hThread=NULL;
}

pondering::~pondering(){
    stop();
}


void pondering::start(){
    //we want only one thread MAX!
    if (m_hThread!=NULL || ponderingEnabled==TRUE)
       {return;}
    ponderingEnabled=TRUE;  
    DWORD tid = 0;                           
	m_hThread = (unsigned long*)CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)pondering_proc,(pondering*)this,0,&tid);
	if(m_hThread != NULL) {
        SetThreadPriority(m_hThread,THREAD_PRIORITY_NORMAL);
	}
}

void pondering::run(){
    //fprintf(debugfile,"enter run\n");
    s.think(root, 100000000, 20);
    //fprintf(debugfile,"exit run\n");
}

void pondering::stop(){
    //fprintf(debugfile,"enter stop\n");
	if(m_hThread == NULL){
        return;
    }	
	ponderingEnabled=FALSE;
    WaitForSingleObject(m_hThread,INFINITE);
	CloseHandle(m_hThread);
	m_hThread = NULL;
    //printf("exit stop\n");
}



/*
void Thread::start() {
	DWORD tid = 0;	
	m_hThread = (unsigned long*)CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)_ou_thread_proc,(Thread*)this,0,&tid);
	if(m_hThread == NULL) {
		throw ThreadException("Failed to create thread");
	}else {
		SetThreadPriority(m_hThread,P_NORMAL);
	}
}

void Thread::stop() {
	if(m_hThread == NULL) return;	
	WaitForSingleObject(m_hThread,INFINITE);
	CloseHandle(m_hThread);
	m_hThread = NULL;
}*/

